﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;

namespace HeuristicLab.Core {
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("04788331-AEC8-4D8B-801E-1600F164CEC6")]
  public interface IArc : IItem {
    IVertex Source { get; }
    IVertex Target { get; }
    string Label { get; set; }
    double Weight { get; set; }

    event EventHandler Changed; // generic event for when the label, weight or data were changed
  }

  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("AF7C35B1-3040-481A-AE19-FFDE4C517AF5")]
  public interface IArc<T> : IArc where T : class,IDeepCloneable {
    T Data { get; set; }
  }
}
