#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;

namespace HeuristicLab.Core {
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("94076B82-0D5A-4947-B215-081960703C0B")]
  public interface INamedItem : IItem {
    string Name { get; set; }
    bool CanChangeName { get; }
    string Description { get; set; }
    bool CanChangeDescription { get; }

    event EventHandler<CancelEventArgs<string>> NameChanging;
    event EventHandler NameChanged;
    event EventHandler DescriptionChanged;
  }
}
